
#define equ .equ
#define EQU .equ
#define end .end
#define END .end

#include "includes/ti83asm.inc"
;#include "includes/ion.inc"  
#include "includes/tokens.inc"
#define best_score 8270h
#define buf1 8771h
#define buf2 buf1+768

.org 9327h
   xor   a
   jr    nc,restart     
   .db   "Hunt the moles",0

restart:

  ; Reset le score
  ld hl, score
  ld a, 0
  ld (hl), 0

  ; Reset les flags
  ld hl, m1
  ld a, 0
  ld (hl), a
  push hl
  pop de
  inc de
  ld bc,5
  ldir

  ld a, 255
  ld hl, s
  ld (hl), a

  ; effacer les buffers
  ;call clr_buffers

  call BUFCLR
  call GreyScaleOn
KeyLoop:
  call random
  call print_board
  ;call print_hammer

  ld     a,$FF            
  out    (1),a            
  ld     a,$FE           
  out    (1),a          
  in     a,(1)         
  bit    0,a          
  call   z,bas       
  bit    1,a
  call   z,gauche         
  bit    2,a
  call   z,droite         

spend_time:
  ld hl, s
  dec (hl)
  ld a,(hl)
  or a
  jp z, fin

  JR KeyLoop
fin:
  call clr_buffers
  call GreyScaleOff
  call BUFCLR
  call BUFCOPY


  ld hl,0030
  ld (curcol),hl
  ld (pencol), hl
  ld hl, your_score
  call   _vputs

  
  ld hl, $1E1E
  ld (curcol),hl
  ld (pencol), hl
  ld hl, your_best_score
  ;call   _vputs

  
  ld hl, $3000
  ld (curcol),hl
  ld (pencol), hl
  ld hl, press_up_to_retry
  call   _vputs

  ld hl, $3800
  ld (curcol),hl
  ld (pencol), hl
  ld hl, press_enter_to_quit
  call   _vputs



  ld hl,2
  ld (currow),hl
  ld hl,3
  ld (curcol),hl
  ld hl, score
  ld a, (hl)
  ld hl, 0
  ld l,a
  call   _dispHL
regetkey:
  call _getKey
  sub 3
  jp z, restart
  sub 2
  jp nz, regetkey
  ;call GOHOME
  ret

your_score:
  .db "Your score : ", 0

your_best_score:
  .db "High score : ", 0

press_up_to_retry:
  .db "---- Press up to retry ----", 0
press_enter_to_quit:
  .db "---- Press enter to quit ----", 0

gauche:
  call TEST_LOCK
  push af
  ld a, 9
  ld hl, h1
  ld (hl), a
  ld hl, m1
  call INCREASE_SCORE

  pop af
  ret


bas:
  call TEST_LOCK
  push af
  ld a, 9
  ld hl, h2
  ld (hl), a
  ld hl, m2
  call INCREASE_SCORE
  pop af
  ret

droite:
  call TEST_LOCK
  push af
  ld a, 9
  ld hl, h3
  ld (hl), a
  ld hl, m3
  call INCREASE_SCORE
  pop af
  ret


INCREASE_SCORE:
  push hl
  ld a,(hl)
  ld hl,difficulty
  ld b, (hl)
  sub b
  jp p, empty 
  ld hl, score
  inc (hl)
  
empty:
  pop hl
  ld a, r
  ld b, 100
  add a, b
  ld (hl),a
  ret


TEST_LOCK:
  push af
  ld hl, h1
  ld a,(hl)
  or a
  jp nz, locked
  ld hl, h2
  ld a,(hl)
  or a
  jp nz, locked
  ld hl, h3
  ld a,(hl)
  or a
  jp nz, locked
  pop af
  ret
locked:
  pop af
  pop hl
  pop af
  jp KeyLoop
   
  

score:
  .db 0


s:
  .db 255
  ;.db 10


#include "sprites.asm"
#include "board.asm"
#include "greylib.asm"
